/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
function isHtmlContent(responseHeaders) {
  if (!responseHeaders) {
    // this should never happen, but better safe than sorry;
    // worst case, we parse image data or something
    return true;
  }

  // we may want to do a case-insensitive search through object keys here
  let contentType =
    responseHeaders['Content-Type'] || responseHeaders['content-type'];
  if (contentType) contentType = contentType.toLowerCase();

  return (
    !contentType ||
    contentType.indexOf('text') !== -1 ||
    contentType.indexOf('html') !== -1
  );
}

function isParseableResponse(responseHeaders) {
  if (!responseHeaders) {
    // this should never happen, but better safe than sorry;
    // worst case, we parse image data or something
    return true;
  }

  // we may want to do a case-insensitive search through object keys here
  let contentType =
    responseHeaders['Content-Type'] || responseHeaders['content-type'];
  if (contentType) contentType = contentType.toLowerCase();

  return (
    !contentType ||
    contentType.includes('text') ||
    contentType.includes('html') ||
    contentType.includes('xml') ||
    contentType.includes('json') ||
    contentType.includes('soap') ||
    contentType.includes('pdf')
  );
}

module.exports.isParseableResponse = isParseableResponse;
module.exports.isHtmlContent = isHtmlContent;
